<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>/vagrant/python/networking/client-server/server.py.html</title>
<meta name="Generator" content="Vim/8.1">
<meta name="plugin-version" content="vim8.1_v1">
<meta name="syntax" content="python">
<meta name="settings" content="use_css,pre_wrap,no_foldcolumn,prevent_copy=">
<meta name="colorscheme" content="none">
<style type="text/css">
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #ffffff; background-color: #000000; }
body { font-family: monospace; color: #ffffff; background-color: #000000; }
* { font-size: 1em; }
.PreProc { color: #5fd7ff; }
.Comment { color: #00ffff; }
.Constant { color: #ff40ff; }
.Identifier { color: #00ffff; font-weight: bold; }
.Statement { color: #ffff00; }
-->
</style>
</head>
<body>
<pre id='vimCodeElement'>
<span class="Comment">#!/usr/bin/env python3</span>
<span class="Comment">#</span>
<span class="Comment"># Este codigo fue tomado de: <a href="https://pythongeeks.org/networking-in-python/">https://pythongeeks.org/networking-in-python/</a></span>
<span class="Comment">#</span>
<span class="Comment"># Este es un servidor un solo hilo y no acepta acceso concurrente.</span>
<span class="Comment">#</span>
<span class="Comment"># Author: John Sanabria - john.sanabria@correounivalle.edu.co</span>
<span class="Comment"># Date: 2022-03-15</span>
<span class="Comment"># </span>
<span class="Comment"># 2022-03-15:</span>
<span class="Comment">#   Se hicieron los siguientes ajustes en el codigo:</span>
<span class="Comment">#   - To change ‘c.send’ by ‘client.send’</span>
<span class="Comment">#   - To change ‘sct.recv’ by ‘client.recv’</span>
<span class="Comment">#   - To change ‘sct.close’ by ‘client.close’</span>
<span class="Comment">#</span>
<span class="Comment"># importing the module</span>
<span class="PreProc">import</span> socket

<span class="Comment"># creating the socket </span>
sct=socket.socket()
<span class="Comment"># binding the IP address and the port number by passing them as elements </span>
<span class="Comment"># of a tuple </span>
sct.bind((socket.gethostname(),<span class="Constant">9999</span>))
<span class="Constant">'''</span>
<span class="Constant">Here we used 9999 as the port number. The port number can be in </span>
<span class="Constant">the range of 0 to 65535. We can use any port number that is free. </span>
<span class="Constant">9999 is one of them. So, we used it.</span>
<span class="Constant">'''</span>
<span class="Comment"># This listens and waits for 5 connections. We should give any limit, here 5, </span>
<span class="Comment"># as we cannot accept infinite connections</span>
sct.listen(<span class="Constant">5</span>)
<span class="Identifier">print</span>(<span class="Constant">'</span><span class="Constant">Waiting for connection...</span><span class="Constant">'</span>)

<span class="Comment"># Now for every connection we want to interact. So we will write a loop</span>
cont=<span class="Constant">0</span>
<span class="Statement">while</span> <span class="Identifier">True</span>:
    <span class="Comment"># this function accepts the connection from client and returns </span>
    <span class="Comment"># the client name and its address</span>
    client,add=sct.accept()
    cont = cont + <span class="Constant">1</span>

    <span class="Comment"># sending a TCP message to the client in the form of bytes </span>
    client.send(<span class="Identifier">bytes</span>(<span class="Constant">'</span><span class="Constant">Hello! Welcome to Pythongeeks</span><span class="Constant">'</span>,<span class="Constant">'</span><span class="Constant">utf-8</span><span class="Constant">'</span>))

    <span class="Comment"># getting the TCP message from the client and decoding it </span>
    c_msg=client.recv(<span class="Constant">1024</span>).decode()
    <span class="Comment"># printing the message</span>
    <span class="Identifier">print</span>(f<span class="Constant">'</span><span class="Constant">[{cont}] The message from the client {client} is {c_msg}</span><span class="Constant">'</span>)
    <span class="Comment"># This stops the connection</span>
    client.close()
</pre>
</body>
</html>
<!-- vim: set foldmethod=manual : -->
